/*
 * QMAZDA project: Image Analysis and Pattern Recognition
 *
 * Copyright 2013-2017 Piotr M. Szczypiński <piotr.szczypinski@p.lodz.pl>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "templates.h"

ItemTemplate localTreeTemplate[218]=
{
    {"t;?;Y;R;G;B;U;V;H;S;I;Q;u;v;i;q;h;x;y;z;L;a;b/Color channel", &StubItemColorTransform::New},
    {".t;c;c;s/Sliding window shape", &StubItemPreWindow::New},
    {"..i;5;1;32/Sliding window radius", &StubItemWindow::New},
    {"...t;?;D;N;S;M/Grayscale normalization", &StubItemNormalization::New},
    {"....i;5;1;16/Bits per pixel", &StubItemBits::New},
    {".....t;?;Grlm/Gray level run length matrix", &StubItemThrough::New},
    {"......t;H;H;V;N;Z;X/Direction", &StubItemGrlm::New},
    {".......n;RLNonUni", &StubItemGrlmFeature::New},
    {".......n;GLevNonUn", &StubItemGrlmFeature::New},
    {".......n;LngREmph", &StubItemGrlmFeature::New},
    {".......n;ShrtREmp", &StubItemGrlmFeature::New},
    {".......n;Fraction", &StubItemGrlmFeature::New},
    {".......n;MRLNonUni", &StubItemGrlmFeature::New},
    {".......n;MGLevNonUn", &StubItemGrlmFeature::New},
    {".....t;?;Glcm;Glch/Gray level coocurrence matrix", &StubItemThrough::New},
    {"......t;H;H;V;N;Z;X/Direction", &StubItemThrough::New},
    {".......i;1;1;9/Offset", &StubItemGlcm::New},
    {"........n;Area", &StubItemGlcmFeature::New},
    {"........n;AngScMom", &StubItemGlcmFeature::New},
    {"........n;Contrast", &StubItemGlcmFeature::New},
    {"........n;Correlat", &StubItemGlcmFeature::New},
    {"........n;SumOfSqs", &StubItemGlcmFeature::New},
    {"........n;InvDfMom", &StubItemGlcmFeature::New},
    {"........n;SumAverg", &StubItemGlcmFeature::New},
    {"........n;SumVarnc", &StubItemGlcmFeature::New},
    {"........n;SumEntrp", &StubItemGlcmFeature::New},
    {"........n;Entropy", &StubItemGlcmFeature::New},
    {"........n;DifVarnc", &StubItemGlcmFeature::New},
    {"........n;DifEntrp", &StubItemGlcmFeature::New},

    {"........n;ClustShd", &StubItemGlcmFeature::New},
    {"........n;ClustPrm", &StubItemGlcmFeature::New},


    {".....t;?;Arm", &StubItemArm::New},
    {"......n;Teta1", &StubItemArmFeature::New},
    {"......n;Teta2", &StubItemArmFeature::New},
    {"......n;Teta3", &StubItemArmFeature::New},
    {"......n;Teta4", &StubItemArmFeature::New},
    {"......n;Sigma", &StubItemArmFeature::New},
    {".....t;?;Grad/Image gradient magnitude", &StubItemGradient::New},
    {"......n;Area", &StubItemGradientFeature::New},
    {"......n;Mean", &StubItemGradientFeature::New},
    {"......n;Variance", &StubItemGradientFeature::New},
    {"......n;Skewness", &StubItemGradientFeature::New},
    {"......n;Kurtosis", &StubItemGradientFeature::New},
    {"......n;NonZeros", &StubItemGradientFeature::New},
    {".....t;?;Hist/Image histogram", &StubItemHistogram::New},
    {"......n;Area", &StubItemHistogramFeature::New},
    {"......n;Mean", &StubItemHistogramFeature::New},
    {"......n;Variance", &StubItemHistogramFeature::New},
    {"......n;Skewness", &StubItemHistogramFeature::New},
    {"......n;Kurtosis", &StubItemHistogramFeature::New},
    {"......n;Perc01", &StubItemHistogramFeature::New},
    {"......n;Perc10", &StubItemHistogramFeature::New},
    {"......n;Perc50", &StubItemHistogramFeature::New},
    {"......n;Perc90", &StubItemHistogramFeature::New},
    {"......n;Perc99", &StubItemHistogramFeature::New},
    {"......n;Maxm01", &StubItemHistogramFeature::New},
    {"......n;Domn01", &StubItemHistogramFeature::New},
    {"......n;Maxm10", &StubItemHistogramFeature::New},
    {"......n;Domn10", &StubItemHistogramFeature::New},

    {".....t;?;Hog/Histogram of oriented gradients", &StubItemThrough::New},
    {"......t;?;O4b/Number of angular bins", &StubItemHog::New},
    {".......r;?;0;3/Argument of the histogram", &StubItemHogFeature::New},
    {"......t;?;O8b/Number of angular bins", &StubItemHog::New},
    {".......r;?;0;7/Argument of the histogram", &StubItemHogFeature::New},
    {"......t;?;O16b/Number of angular bins", &StubItemHog::New},
    {".......r;?;0;15/Argument of the histogram", &StubItemHogFeature::New},
    {"......t;?;O32b/Number of angular bins", &StubItemHog::New},
    {".......r;?;0;31/Argument of the histogram", &StubItemHogFeature::New},

    {".....t;?;Dwt/Digital wavelet transform", &StubItemThrough::New},
    {"......t;Haar;Haar/Haar wavelet", &StubItemHaar::New},
    {".......n;S1HH", &StubItemFinal::New},
    {".......n;S1HL", &StubItemFinal::New},
    {".......n;S1LH", &StubItemFinal::New},
    {".......n;S2HH", &StubItemFinal::New},
    {".......n;S2HL", &StubItemFinal::New},
    {".......n;S2LH", &StubItemFinal::New},
    {".......n;S3HH", &StubItemFinal::New},
    {".......n;S3HL", &StubItemFinal::New},
    {".......n;S3LH", &StubItemFinal::New},
    {".......n;S4HH", &StubItemFinal::New},
    {".......n;S4HL", &StubItemFinal::New},
    {".......n;S4LH", &StubItemFinal::New},
    {".......n;S5HH", &StubItemFinal::New},
    {".......n;S5HL", &StubItemFinal::New},
    {".......n;S5LH", &StubItemFinal::New},
    {".......n;S6HH", &StubItemFinal::New},
    {".......n;S6HL", &StubItemFinal::New},
    {".......n;S6LH", &StubItemFinal::New},
    {".......n;S7HH", &StubItemFinal::New},
    {".......n;S7HL", &StubItemFinal::New},
    {".......n;S7LH", &StubItemFinal::New},
    {".......n;S8HH", &StubItemFinal::New},
    {".......n;S8HL", &StubItemFinal::New},
    {".......n;S8LH", &StubItemFinal::New},

    {"...t;?;Lbp/Local binary patterns", &StubItemThrough::New},
    {"....t;?;Oc4n/Over-complete 4 neighbors", &StubItemLbp::New},
    {".....r;?;0;15/Argument of the histogram", &StubItemLbpFeature::New},
    {"....t;?;Oc8n/Over-complete 8 neighbors", &StubItemLbp::New},
    {".....r;?;0;255/Argument of the histogram", &StubItemLbpFeature::New},
    {"....t;?;Tr4n/Transition 4 neighbors", &StubItemLbp::New},
    {".....r;?;0;14/Argument of the histogram", &StubItemLbpFeature::New},
    {"....t;?;Tr8n/Transition 8 neighbors", &StubItemLbp::New},
    {".....r;?;0;254/Argument of the histogram", &StubItemLbpFeature::New},
    {"....t;?;Cs4n/Center-symmetric 4 neighbors", &StubItemLbp::New},
    {".....r;?;0;3/Argument of the histogram", &StubItemLbpFeature::New},
    {"....t;?;Cs8n/Center-symmetric 8 neighbors", &StubItemLbp::New},
    {".....r;?;0;15/Argument of the histogram", &StubItemLbpFeature::New},
    {"....t;?;Cs12n/Center-symmetric 12 neighbors", &StubItemLbp::New},
    {".....r;?;0;63/Argument of the histogram", &StubItemLbpFeature::New},

    {".t;D;D;N;S;M/Grayscale normalization", &StubItemNormalization::New},
    {"..i;5;1;16/Bits per pixel", &StubItemBits::New},
    {"...t;c;c;s/Sliding window shape", &StubItemPreWindow::New},
    {"....i;5;1;32/Sliding window radius", &StubItemWindow::New},
    {".....t;?;Grlm/Gray level run length matrix", &StubItemThrough::New},
    {"......t;H;H;V;N;Z;X/Direction", &StubItemGrlm::New},
    {".......n;RLNonUni", &StubItemGrlmFeature::New},
    {".......n;GLevNonUn", &StubItemGrlmFeature::New},
    {".......n;LngREmph", &StubItemGrlmFeature::New},
    {".......n;ShrtREmp", &StubItemGrlmFeature::New},
    {".......n;Fraction", &StubItemGrlmFeature::New},
    {".......n;MRLNonUni", &StubItemGrlmFeature::New},
    {".......n;MGLevNonUn", &StubItemGrlmFeature::New},
    {".....t;?;Glcm;Glch/Gray level coocurrence matrix", &StubItemThrough::New},
    {"......t;H;H;V;N;Z;X/Direction", &StubItemThrough::New},
    {".......i;1;1;9/Offset", &StubItemGlcm::New},
    {"........n;Area", &StubItemGlcmFeature::New},
    {"........n;AngScMom", &StubItemGlcmFeature::New},
    {"........n;Contrast", &StubItemGlcmFeature::New},
    {"........n;Correlat", &StubItemGlcmFeature::New},
    {"........n;SumOfSqs", &StubItemGlcmFeature::New},
    {"........n;InvDfMom", &StubItemGlcmFeature::New},
    {"........n;SumAverg", &StubItemGlcmFeature::New},
    {"........n;SumVarnc", &StubItemGlcmFeature::New},
    {"........n;SumEntrp", &StubItemGlcmFeature::New},
    {"........n;Entropy", &StubItemGlcmFeature::New},
    {"........n;DifVarnc", &StubItemGlcmFeature::New},
    {"........n;DifEntrp", &StubItemGlcmFeature::New},

    {"........n;ClustShd", &StubItemGlcmFeature::New},
    {"........n;ClustPrm", &StubItemGlcmFeature::New},


    {".....t;?;Arm", &StubItemArm::New},
    {"......n;Teta1", &StubItemArmFeature::New},
    {"......n;Teta2", &StubItemArmFeature::New},
    {"......n;Teta3", &StubItemArmFeature::New},
    {"......n;Teta4", &StubItemArmFeature::New},
    {"......n;Sigma", &StubItemArmFeature::New},
    {".....t;?;Grad/Image gradient magnitude", &StubItemGradient::New},
    {"......n;Area", &StubItemGradientFeature::New},
    {"......n;Mean", &StubItemGradientFeature::New},
    {"......n;Variance", &StubItemGradientFeature::New},
    {"......n;Skewness", &StubItemGradientFeature::New},
    {"......n;Kurtosis", &StubItemGradientFeature::New},
    {"......n;NonZeros", &StubItemGradientFeature::New},
    {".....t;?;Hist/Image histogram", &StubItemHistogram::New},
    {"......n;Area", &StubItemHistogramFeature::New},
    {"......n;Mean", &StubItemHistogramFeature::New},
    {"......n;Variance", &StubItemHistogramFeature::New},
    {"......n;Skewness", &StubItemHistogramFeature::New},
    {"......n;Kurtosis", &StubItemHistogramFeature::New},
    {"......n;Perc01", &StubItemHistogramFeature::New},
    {"......n;Perc10", &StubItemHistogramFeature::New},
    {"......n;Perc50", &StubItemHistogramFeature::New},
    {"......n;Perc90", &StubItemHistogramFeature::New},
    {"......n;Perc99", &StubItemHistogramFeature::New},
    {"......n;Maxm01", &StubItemHistogramFeature::New},
    {"......n;Domn01", &StubItemHistogramFeature::New},
    {"......n;Maxm10", &StubItemHistogramFeature::New},
    {"......n;Domn10", &StubItemHistogramFeature::New},

    {".....t;?;Hog/Histogram of oriented gradients", &StubItemThrough::New},
    {"......t;?;O4b/Number of angular bins", &StubItemHog::New},
    {".......r;?;0;3/Argument of the histogram", &StubItemHogFeature::New},
    {"......t;?;O8b/Number of angular bins", &StubItemHog::New},
    {".......r;?;0;7/Argument of the histogram", &StubItemHogFeature::New},
    {"......t;?;O16b/Number of angular bins", &StubItemHog::New},
    {".......r;?;0;15/Argument of the histogram", &StubItemHogFeature::New},
    {"......t;?;O32b/Number of angular bins", &StubItemHog::New},
    {".......r;?;0;31/Argument of the histogram", &StubItemHogFeature::New},

    {".....t;?;Dwt/Digital wavelet transform", &StubItemThrough::New},
    {"......t;Haar;Haar/Haar wavelet", &StubItemHaar::New},
    {".......n;S1HH", &StubItemFinal::New},
    {".......n;S1HL", &StubItemFinal::New},
    {".......n;S1LH", &StubItemFinal::New},
    {".......n;S2HH", &StubItemFinal::New},
    {".......n;S2HL", &StubItemFinal::New},
    {".......n;S2LH", &StubItemFinal::New},
    {".......n;S3HH", &StubItemFinal::New},
    {".......n;S3HL", &StubItemFinal::New},
    {".......n;S3LH", &StubItemFinal::New},
    {".......n;S4HH", &StubItemFinal::New},
    {".......n;S4HL", &StubItemFinal::New},
    {".......n;S4LH", &StubItemFinal::New},
    {".......n;S5HH", &StubItemFinal::New},
    {".......n;S5HL", &StubItemFinal::New},
    {".......n;S5LH", &StubItemFinal::New},
    {".......n;S6HH", &StubItemFinal::New},
    {".......n;S6HL", &StubItemFinal::New},
    {".......n;S6LH", &StubItemFinal::New},
    {".......n;S7HH", &StubItemFinal::New},
    {".......n;S7HL", &StubItemFinal::New},
    {".......n;S7LH", &StubItemFinal::New},
    {".......n;S8HH", &StubItemFinal::New},
    {".......n;S8HL", &StubItemFinal::New},
    {".......n;S8LH", &StubItemFinal::New},

    {"...t;?;Gab/Gabor transform", &StubItemThrough::New},
    {"....i;12;1;128/Standard deviation of the Gaussian envelope", &StubItemThrough::New},
    {".....t;?;H;U;Z;S;V;G;N;J;X;O/Direction", &StubItemThrough::New},
    {"......i;5;2;32/Period of the sinwave", &StubItemGaborLocal::New},
    {".......n;Mag", &StubItemGaborFeature::New},
    {".......n;Phase", &StubItemGaborFeature::New},
    {".......n;Re", &StubItemGaborFeature::New},
    {".......n;Im", &StubItemGaborFeature::New},

    {".....t;?;A/Direction", &StubItemThrough::New},
    {"......i;?;0;3599/Angle in tens of degrees", &StubItemThrough::New},
    {".......t;A;A", &StubItemThrough::New},
    {"........i;5;2;32/Period of the sinwave", &StubItemGaborLocal::New},
    {".........n;Mag", &StubItemGaborFeature::New},
    {".........n;Phase", &StubItemGaborFeature::New},
    {".........n;Re", &StubItemGaborFeature::New},
    {".........n;Im", &StubItemGaborFeature::New}
};



ItemTemplate roiTreeTemplate[248]=
{
    {"t;?;Y;R;G;B;U;V;H;S;I;Q;u;v;i;q;h;x;y;z;L;a;b/Color channel", &StubItemColorTransform::New},
    {".t;?;D;N;S;M/Grayscale normalization", &StubItemNormalization::New},
    {"..i;5;1;16/Bits per pixel", &StubItemBits::New},
    {"...t;?;Gab/Select algorithm", &StubItemThrough::New},
    {"....i;12;1;128/Standard deviation of the Gaussian envelope", &StubItemThrough::New},
    {".....t;?;H;U;Z;S;V;G;N;J;X;O/Direction", &StubItemThrough::New},
    {"......i;5;2;32/Period of the sinwave", &StubItemGabor::New},
    {".......n;Area", &StubItemGaborFeature::New},
    {".......n;Mag", &StubItemGaborFeature::New},

    {".....t;?;A/Direction", &StubItemThrough::New},
    {"......i;?;0;3599/Angle in tens of degrees", &StubItemThrough::New},
    {".......t;A;A", &StubItemThrough::New},
    {"........i;5;2;32/Period of the sinwave", &StubItemGaborLocal::New},
    {".........n;Mag", &StubItemGaborFeature::New},

    {"...t;?;Grlm/Gray level run length matrix", &StubItemThrough::New},
    {"....t;H;H;V;N;Z;X/Direction", &StubItemGrlm::New},
    {".....n;RLNonUni", &StubItemGrlmFeature::New},
    {".....n;GLevNonUn", &StubItemGrlmFeature::New},
    {".....n;LngREmph", &StubItemGrlmFeature::New},
    {".....n;ShrtREmp", &StubItemGrlmFeature::New},
    {".....n;Fraction", &StubItemGrlmFeature::New},
    {".....n;MRLNonUni", &StubItemGrlmFeature::New},
    {".....n;MGLevNonUn", &StubItemGrlmFeature::New},

    {"...t;?;Glcm;Glch/Gray level coocurrence matrix", &StubItemThrough::New},
    {"....t;H;H;V;N;Z;X/Direction", &StubItemThrough::New},
    {".....i;1;1;9/Offset", &StubItemGlcm::New},
    {"......n;Area", &StubItemGlcmFeature::New},
    {"......n;AngScMom", &StubItemGlcmFeature::New},
    {"......n;Contrast", &StubItemGlcmFeature::New},
    {"......n;Correlat", &StubItemGlcmFeature::New},
    {"......n;SumOfSqs", &StubItemGlcmFeature::New},
    {"......n;InvDfMom", &StubItemGlcmFeature::New},
    {"......n;SumAverg", &StubItemGlcmFeature::New},
    {"......n;SumVarnc", &StubItemGlcmFeature::New},
    {"......n;SumEntrp", &StubItemGlcmFeature::New},
    {"......n;Entropy", &StubItemGlcmFeature::New},
    {"......n;DifVarnc", &StubItemGlcmFeature::New},
    {"......n;DifEntrp", &StubItemGlcmFeature::New},

    {"......n;ClustShd", &StubItemGlcmFeature::New},
    {"......n;ClustPrm", &StubItemGlcmFeature::New},


    {"...t;?;Arm", &StubItemArm::New},
    {"....n;Teta1", &StubItemArmFeature::New},
    {"....n;Teta2", &StubItemArmFeature::New},
    {"....n;Teta3", &StubItemArmFeature::New},
    {"....n;Teta4", &StubItemArmFeature::New},
    {"....n;Sigma", &StubItemArmFeature::New},
    {"...t;?;Grad/Image gradient magnitude", &StubItemGradient::New},
    {"....n;Area", &StubItemGradientFeature::New},
    {"....n;Mean", &StubItemGradientFeature::New},
    {"....n;Variance", &StubItemGradientFeature::New},
    {"....n;Skewness", &StubItemGradientFeature::New},
    {"....n;Kurtosis", &StubItemGradientFeature::New},
    {"....n;NonZeros", &StubItemGradientFeature::New},
    {"...t;?;Hist/Image histogram", &StubItemHistogram::New},
    {"....n;Area", &StubItemHistogramFeature::New},
    {"....n;Mean", &StubItemHistogramFeature::New},
    {"....n;Variance", &StubItemHistogramFeature::New},
    {"....n;Skewness", &StubItemHistogramFeature::New},
    {"....n;Kurtosis", &StubItemHistogramFeature::New},
    {"....n;Perc01", &StubItemHistogramFeature::New},
    {"....n;Perc10", &StubItemHistogramFeature::New},
    {"....n;Perc50", &StubItemHistogramFeature::New},
    {"....n;Perc90", &StubItemHistogramFeature::New},
    {"....n;Perc99", &StubItemHistogramFeature::New},
    {"....n;Maxm01", &StubItemHistogramFeature::New},
    {"....n;Domn01", &StubItemHistogramFeature::New},
    {"....n;Maxm10", &StubItemHistogramFeature::New},
    {"....n;Domn10", &StubItemHistogramFeature::New},

    {"...t;?;Hog/Histogram of oriented gradients", &StubItemThrough::New},
    {"....t;?;O4b/Number of angular bins", &StubItemHog::New},
    {".....r;?;0;3/Argument of the histogram", &StubItemHogFeature::New},
    {"....t;?;O8b/Number of angular bins", &StubItemHog::New},
    {".....r;?;0;7/Argument of the histogram", &StubItemHogFeature::New},
    {"....t;?;O16b/Number of angular bins", &StubItemHog::New},
    {".....r;?;0;15/Argument of the histogram", &StubItemHogFeature::New},
    {"....t;?;O32b/Number of angular bins", &StubItemHog::New},
    {".....r;?;0;31/Argument of the histogram", &StubItemHogFeature::New},

    {"...t;?;Dwt/Digital wavelet transform", &StubItemThrough::New},
    {"....t;Haar;Haar/Haar wavelet", &StubItemHaar::New},
    {".....n;S1HH", &StubItemFinal::New},
    {".....n;S1HL", &StubItemFinal::New},
    {".....n;S1LH", &StubItemFinal::New},
    {".....n;S2HH", &StubItemFinal::New},
    {".....n;S2HL", &StubItemFinal::New},
    {".....n;S2LH", &StubItemFinal::New},
    {".....n;S3HH", &StubItemFinal::New},
    {".....n;S3HL", &StubItemFinal::New},
    {".....n;S3LH", &StubItemFinal::New},
    {".....n;S4HH", &StubItemFinal::New},
    {".....n;S4HL", &StubItemFinal::New},
    {".....n;S4LH", &StubItemFinal::New},
    {".....n;S5HH", &StubItemFinal::New},
    {".....n;S5HL", &StubItemFinal::New},
    {".....n;S5LH", &StubItemFinal::New},
    {".....n;S6HH", &StubItemFinal::New},
    {".....n;S6HL", &StubItemFinal::New},
    {".....n;S6LH", &StubItemFinal::New},
    {".....n;S7HH", &StubItemFinal::New},
    {".....n;S7HL", &StubItemFinal::New},
    {".....n;S7LH", &StubItemFinal::New},
    {".....n;S8HH", &StubItemFinal::New},
    {".....n;S8HL", &StubItemFinal::New},
    {".....n;S8LH", &StubItemFinal::New},

    {".t;?;Lbp/Local binary patterns", &StubItemThrough::New},
    {"..t;?;Oc4n/Over-complete 4 neighbors", &StubItemLbp::New},
    {"...r;?;0;15/Argument of the histogram", &StubItemLbpFeature::New},
    {"..t;?;Oc8n/Over-complete 8 neighbors", &StubItemLbp::New},
    {"...r;?;0;255/Argument of the histogram", &StubItemLbpFeature::New},
    {"..t;?;Tr4n/Transition 4 neighbors", &StubItemLbp::New},
    {"...r;?;0;14/Argument of the histogram", &StubItemLbpFeature::New},
    {"..t;?;Tr8n/Transition 8 neighbors", &StubItemLbp::New},
    {"...r;?;0;254/Argument of the histogram", &StubItemLbpFeature::New},
    {"..t;?;Cs4n/Center-symmetric 4 neighbors", &StubItemLbp::New},
    {"...r;?;0;3/Argument of the histogram", &StubItemLbpFeature::New},
    {"..t;?;Cs8n/Center-symmetric 8 neighbors", &StubItemLbp::New},
    {"...r;?;0;15/Argument of the histogram", &StubItemLbpFeature::New},
    {"..t;?;Cs12n/Center-symmetric 12 neighbors", &StubItemLbp::New},
    {"...r;?;0;63/Argument of the histogram", &StubItemLbpFeature::New},

    {"t;?;Mor/Morphological features", &StubItemThrough::New},
    {".t;?;Mz/MaZda implementation", &StubItemShapeMz::New},
    {"..n;X", &StubItemShapeFeature::New},
    {"..n;Y", &StubItemShapeFeature::New},
    {"..n;F", &StubItemShapeFeature::New},
    {"..n;Spol", &StubItemShapeFeature::New},
    {"..n;Smax", &StubItemShapeFeature::New},
    {"..n;Aox", &StubItemShapeFeature::New},
    {"..n;Ug", &StubItemShapeFeature::New},
    {"..n;Uw", &StubItemShapeFeature::New},
    {"..n;Fmax", &StubItemShapeFeature::New},
    {"..n;Fmin", &StubItemShapeFeature::New},
    {"..n;Fh", &StubItemShapeFeature::New},
    {"..n;Fv", &StubItemShapeFeature::New},
    {"..n;Mmin", &StubItemShapeFeature::New},
    {"..n;Mmax", &StubItemShapeFeature::New},
    {"..n;Maver", &StubItemShapeFeature::New},
    {"..n;Ft", &StubItemShapeFeature::New},
    {"..n;Ul", &StubItemShapeFeature::New},
    {"..n;S1", &StubItemShapeFeature::New},
    {"..n;S2", &StubItemShapeFeature::New},
    {"..n;Lsz", &StubItemShapeFeature::New},
    {"..n;S", &StubItemShapeFeature::New},
    {"..n;L", &StubItemShapeFeature::New},
    {"..n;SxL", &StubItemShapeFeature::New},
    {"..n;D1", &StubItemShapeFeature::New},
    {"..n;D2", &StubItemShapeFeature::New},
    {"..n;Fd2", &StubItemShapeFeature::New},
    {"..n;LmaxE", &StubItemShapeFeature::New},
    {"..n;LminE", &StubItemShapeFeature::New},
    {"..n;FE", &StubItemShapeFeature::New},
    {"..n;W1", &StubItemShapeFeature::New},
    {"..n;W2", &StubItemShapeFeature::New},
    {"..n;W6", &StubItemShapeFeature::New},
    {"..n;W3", &StubItemShapeFeature::New},
    {"..n;W4", &StubItemShapeFeature::New},
    {"..n;W5", &StubItemShapeFeature::New},
    {"..n;W5b", &StubItemShapeFeature::New},
    {"..n;W7", &StubItemShapeFeature::New},
    {"..n;Rs", &StubItemShapeFeature::New},
    {"..n;Rf", &StubItemShapeFeature::New},
    {"..n;Rff", &StubItemShapeFeature::New},
    {"..n;Rc", &StubItemShapeFeature::New},
    {"..n;Rc1", &StubItemShapeFeature::New},
    {"..n;Rc2", &StubItemShapeFeature::New},
    {"..n;Rm", &StubItemShapeFeature::New},
    {"..n;Rb", &StubItemShapeFeature::New},
    {"..n;Rd", &StubItemShapeFeature::New},
    {"..n;Rh", &StubItemShapeFeature::New},
    {"..n;W8", &StubItemShapeFeature::New},
    {"..n;W9", &StubItemShapeFeature::New},
    {"..n;W10", &StubItemShapeFeature::New},
    {"..n;SigR", &StubItemShapeFeature::New},
    {"..n;W11", &StubItemShapeFeature::New},
    {"..n;W12", &StubItemShapeFeature::New},
    {"..n;W13", &StubItemShapeFeature::New},
    {"..n;W14", &StubItemShapeFeature::New},
    {"..n;W15", &StubItemShapeFeature::New},
    {"..n;M2x", &StubItemShapeFeature::New},
    {"..n;M2y", &StubItemShapeFeature::New},
    {"..n;M2xy", &StubItemShapeFeature::New},
    {"..n;Er", &StubItemShapeFeature::New},
    {"..n;Er2", &StubItemShapeFeature::New},
    {"..n;El", &StubItemShapeFeature::New},
    {"..n;El2", &StubItemShapeFeature::New},
    {"..n;Nc", &StubItemShapeFeature::New},
    {"..n;Nv", &StubItemShapeFeature::New},
    {"..n;Nl", &StubItemShapeFeature::New},
    {"..n;Nsz", &StubItemShapeFeature::New},
    {"..n;Ni", &StubItemShapeFeature::New},
    {"..n;Nx", &StubItemShapeFeature::New},
    {"..n;No", &StubItemShapeFeature::New},
    {"..n;Xo", &StubItemShapeFeature::New},
    {"..n;Yo", &StubItemShapeFeature::New},
    {"..n;XYo", &StubItemShapeFeature::New},

    {".t;?;Cv/Based on OpenCV contour extraction", &StubItemShapeCv::New},
    {"..n;PixelsCount", &StubItemShapeFeature::New},
    {"..n;X", &StubItemShapeFeature::New},
    {"..n;Y", &StubItemShapeFeature::New},
    {"..n;ProfileArea", &StubItemShapeFeature::New},
    {"..n;EquivDiameter", &StubItemShapeFeature::New},
    {"..n;Perimeter", &StubItemShapeFeature::New},
    {"..n;Roundness", &StubItemShapeFeature::New},
    {"..n;ElipsAngle", &StubItemShapeFeature::New},
    {"..n;ElipsHeight", &StubItemShapeFeature::New},
    {"..n;ElipsWidth", &StubItemShapeFeature::New},
    {"..n;ElipsElong", &StubItemShapeFeature::New},
    {"..n;MomTheta", &StubItemShapeFeature::New},
    {"..n;MomElong", &StubItemShapeFeature::New},
    {"..n;HuMom1", &StubItemShapeFeature::New},
    {"..n;HuMom2", &StubItemShapeFeature::New},
    {"..n;HuMom3", &StubItemShapeFeature::New},
    {"..n;HuMom4", &StubItemShapeFeature::New},
    {"..n;HuMom5", &StubItemShapeFeature::New},
    {"..n;HuMom6", &StubItemShapeFeature::New},
    {"..n;HuMom7", &StubItemShapeFeature::New},
    {"..n;ChRectWidth", &StubItemShapeFeature::New},
    {"..n;ChRectHeight", &StubItemShapeFeature::New},
    {"..n;ChRectArea", &StubItemShapeFeature::New},
    {"..n;ChArea", &StubItemShapeFeature::New},
    {"..n;ChPerim", &StubItemShapeFeature::New},
    {"..n;ChMinFeret", &StubItemShapeFeature::New},
    {"..n;ChMaxFeret", &StubItemShapeFeature::New},
    {"..n;RadDist", &StubItemShapeFeature::New},
    {"..n;RadDistsqrd", &StubItemShapeFeature::New},
    {"..n;RadDistdev", &StubItemShapeFeature::New},
    {"..n;Radbb", &StubItemShapeFeature::New},

    {".t;?;Itk/Based on itk::LabelImageToShapeLabelMapFilter", &StubItemShape::New},
    {"..n;Area", &StubItemShapeFeature::New},
    {"..n;FullyConnectedFalse", &StubItemShapeFeature::New},
    {"..n;FullyConnectedTrue", &StubItemShapeFeature::New},
    {"..n;SizeX", &StubItemShapeFeature::New},
    {"..n;SizeY", &StubItemShapeFeature::New},
    {"..n;SizeZ", &StubItemShapeFeature::New},
    {"..n;FeretDiameter", &StubItemShapeFeature::New},
    {"..n;CentroidX", &StubItemShapeFeature::New},
    {"..n;CentroidY", &StubItemShapeFeature::New},
    {"..n;CentroidZ", &StubItemShapeFeature::New},
    {"..n;PrincipalMomentX", &StubItemShapeFeature::New},
    {"..n;PrincipalMomentY", &StubItemShapeFeature::New},
    {"..n;PrincipalMomentZ", &StubItemShapeFeature::New},
    {"..n;Tilt", &StubItemShapeFeature::New},
    {"..n;Elongation", &StubItemShapeFeature::New},
    {"..n;Perimeter", &StubItemShapeFeature::New},
    {"..n;Roundness", &StubItemShapeFeature::New},
    {"..n;EquivalentSphericalRadius", &StubItemShapeFeature::New},
    {"..n;EquivalentSphericalPerimeter", &StubItemShapeFeature::New},
    {"..n;EquivalentEllipsoidDiameterX", &StubItemShapeFeature::New},
    {"..n;EquivalentEllipsoidDiameterY", &StubItemShapeFeature::New},
    {"..n;EquivalentEllipsoidDiameterZ", &StubItemShapeFeature::New}

    //{".t;?;Cv/Based on OpenCV", &StubItemFinal::New}
};
